#ifdef __KERNEL__
#ifndef _OR32_SERIAL_H__
#define _OR32_SERIAL_H__

#include <asm/board.h>
#include <linux/config.h>

/* 16 is hardware devisior */
#define BASE_BAUD ( (SYS_CLK/(OR32_CONSOLE_BAUD)) * (9600/16) )

#define RS_TABLE_SIZE  4

/* Standard COM flags (except for COM4, because of the 8514 problem) */
#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF | ASYNC_SKIP_TEST)
#define STD_COM4_FLAGS (ASYNC_BOOT_AUTOCONF)

/* if you do not want it to run in irq mode, just set IRQ to 0 */

#define STD_SERIAL_PORT_DEFNS			\
	/*   UART CLK   PORT       IRQ FLAGS        */			\
	{ 0, BASE_BAUD, 0x90000000, 2, STD_COM4_FLAGS },/* ttyS0 */	\

#ifdef CONFIG_SERIAL_MANY_PORTS
#define EXTRA_SERIAL_PORT_DEFNS
/*
 * add extra serial ports here
 */
#else
#define EXTRA_SERIAL_PORT_DEFNS
#endif

#define HUB6_SERIAL_PORT_DFNS

#define MCA_SERIAL_PORT_DFNS

#define SERIAL_PORT_DFNS		\
	STD_SERIAL_PORT_DEFNS		\
	EXTRA_SERIAL_PORT_DEFNS		\
	HUB6_SERIAL_PORT_DFNS		\
	MCA_SERIAL_PORT_DFNS

#endif /* __ASM_SERIAL_H__ */
#endif /* __KERNEL__ */
